Subject: RE: LSR Self test in Charter

From: "David Allan" <[email-masked]>
Date: Thu, 2 Oct 2003 17:27:11 -0400

Hi George:

> <snipped>
> 
> 
> Excellent point you raise.  One that I've been worried about. 

OK

>  I've sent some new procedures and error conditions to my 
> co-authors on lsp-ping.  One change that I have requested is 
> is that you must check whether the protocol that would have 
> distributed the FEC you have is actually associated with the 
> interface that you received the packet on.  

OK , that will catch a discontinuity when you've neglected to configure LDP
on a link and its a direct adjacency. That's one scenario.... 

> And that that 
> protocol distributed a label (including NULL) for that FEC.  

So we're inferring correctness here. If I got a ping on an interface, and
there is a control adjacency that handed out a FEC label binding on that
interface and the FEC seems legit, then everything must be OK? 

IMHO only an e2e ping that uses the 127/8 can actually catch a real problem
when the unroutable packet comes up for air and the receiving LSR trys to
forward it further...

> Note, I say associated since and LDP session can pertain to 
> multiple interfaces and BGP can pertain to all core facing interfaces.

Are you envisioning self test for CSC...? 

> 
> Another change, intended to help diagnose the problem, is 
> that when you do a trace with a Downstream Mapping TLV, you 
> MUST include null labels in the stack. That way, if you reach 
> the PHP router and it is doing a PoP and forward because it 
> is the end of the LSP (got no label from it's neighbor) it 
> will send back an empty stack, whereas if it was appending an 
> implicit NULL label (still a PHP) it would send back a stack 
> with just the null label as the first entry.

Did you mean "appending an explicit NULL (still a PHP)"?

rgds
Dave

---

From: George Swallow <[email-masked]>
Date: Thu, 02 Oct 2003 17:57:16 -0400

Dave -

> interface and the FEC seems legit, then everything must be OK? 

No, if the packet arrives unlabeled then you necessarily had to have
given out an explicit null label for that FEC.  

> Are you envisioning self test for CSC...? 

The reference to BGP was just for VPNs.  I haven't given a lot of
thought to CSC yet.

> Did you mean "appending an explicit NULL (still a PHP)"?

No, I meant that you're neighbor gave you an implicit null label so
that instead of your normal swap operation of remove and replace the
top label, you just remove the label.

Cheers,

...George

========================================================================
George Swallow             Cisco Systems                  (978) 936-1398
                           1414 Massachusetts Avenue
                           Boxborough, MA 01719